
// ===================================================================================
// ----------------------------------- Put -------------------------------------------
// ===================================================================================

// ***********************************************************************************
// ----------------------------------- EMPTY -----------------------------------------
// ***********************************************************************************
Blockly.Blocks['put2D_1x1_EMPTY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x1_EMPTY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/empty.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putEmptyColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x1_EMPTY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x1_EMPTY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/empty.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putEmptyColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};


// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_1x2_EMPTY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x2_EMPTY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/empty.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putEmptyColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x2_EMPTY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x2_EMPTY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/empty.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putEmptyColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_3x2_EMPTY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_3x2_EMPTY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/empty.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putEmptyColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x3_EMPTY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x3_EMPTY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/empty.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putEmptyColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_4x2_EMPTY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_4x2_EMPTY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/empty.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putEmptyColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x4_EMPTY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x4_EMPTY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/empty.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putEmptyColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// ***********************************************************************************
// ----------------------------------- YELLOW ----------------------------------------
// ***********************************************************************************
Blockly.Blocks['put2D_1x1_YELLOW'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x1_YELLOW ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/yellow.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putYellowColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x1_YELLOW'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x1_YELLOW ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/yellow.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putYellowColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};


// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_1x2_YELLOW'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x2_YELLOW ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/yellow.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putYellowColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x2_YELLOW'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x2_YELLOW ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/yellow.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putYellowColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_3x2_YELLOW'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_3x2_YELLOW ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/yellow.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putYellowColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x3_YELLOW'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x3_YELLOW ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/yellow.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putYellowColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_4x2_YELLOW'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_4x2_YELLOW ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/yellow.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putYellowColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x4_YELLOW'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x4_YELLOW ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/yellow.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putYellowColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};


// ***********************************************************************************
// ----------------------------------- BLUE ------------------------------------------
// ***********************************************************************************
Blockly.Blocks['put2D_1x1_BLUE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x1_BLUE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/blue.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlueColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x1_BLUE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x1_BLUE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/blue.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlueColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};


// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_1x2_BLUE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x2_BLUE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/blue.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlueColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x2_BLUE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x2_BLUE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/blue.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlueColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_3x2_BLUE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_3x2_BLUE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/blue.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlueColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x3_BLUE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x3_BLUE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/blue.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlueColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_4x2_BLUE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_4x2_BLUE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/blue.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlueColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x4_BLUE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x4_BLUE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/blue.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlueColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// ***********************************************************************************
// ----------------------------------- RED -------------------------------------------
// ***********************************************************************************
Blockly.Blocks['put2D_1x1_RED'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x1_RED ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/red.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putRedColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x1_RED'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x1_RED ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/red.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putRedColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};


// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_1x2_RED'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x2_RED ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/red.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putRedColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x2_RED'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x2_RED ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/red.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putRedColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_3x2_RED'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_3x2_RED ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/red.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putRedColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x3_RED'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x3_RED ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/red.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putRedColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_4x2_RED'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_4x2_RED ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/red.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putRedColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x4_RED'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x4_RED ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/red.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putRedColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// ***********************************************************************************
// ----------------------------------- GREEN -----------------------------------------
// ***********************************************************************************
Blockly.Blocks['put2D_1x1_GREEN'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x1_GREEN ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/green.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGreenColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x1_GREEN'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x1_GREEN ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/green.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGreenColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};


// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_1x2_GREEN'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x2_GREEN ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/green.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGreenColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x2_GREEN'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x2_GREEN ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/green.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGreenColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_3x2_GREEN'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_3x2_GREEN ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/green.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGreenColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x3_GREEN'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x3_GREEN ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/green.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGreenColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_4x2_GREEN'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_4x2_GREEN ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/green.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGreenColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x4_GREEN'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x4_GREEN ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/green.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGreenColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// ***********************************************************************************
// ----------------------------------- BLACK -----------------------------------------
// ***********************************************************************************
Blockly.Blocks['put2D_1x1_BLACK'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x1_BLACK ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/black.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlackColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x1_BLACK'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x1_BLACK ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/black.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlackColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};


// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_1x2_BLACK'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x2_BLACK ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/black.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlackColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x2_BLACK'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x2_BLACK ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/black.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlackColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_3x2_BLACK'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_3x2_BLACK ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/black.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlackColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x3_BLACK'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x3_BLACK ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/black.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlackColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_4x2_BLACK'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_4x2_BLACK ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/black.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlackColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x4_BLACK'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x4_BLACK ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/black.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putBlackColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// ***********************************************************************************
// ----------------------------------- GRAY ------------------------------------------
// ***********************************************************************************
Blockly.Blocks['put2D_1x1_GRAY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x1_GRAY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/gray.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGrayColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x1_GRAY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x1_GRAY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/gray.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGrayColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};


// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_1x2_GRAY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x2_GRAY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/gray.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGrayColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x2_GRAY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x2_GRAY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/gray.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGrayColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_3x2_GRAY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_3x2_GRAY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/gray.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGrayColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x3_GRAY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x3_GRAY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/gray.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGrayColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_4x2_GRAY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_4x2_GRAY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/gray.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGrayColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x4_GRAY'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x4_GRAY ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/gray.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putGrayColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// ***********************************************************************************
// ----------------------------------- WHITE -----------------------------------------
// ***********************************************************************************
Blockly.Blocks['put2D_1x1_WHITE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x1_WHITE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/white.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putWhiteColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x1_WHITE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x1_WHITE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/white.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putWhiteColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};


// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_1x2_WHITE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_1x2_WHITE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/white.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putWhiteColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x2_WHITE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x2_WHITE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/white.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putWhiteColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_3x2_WHITE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_3x2_WHITE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/white.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putWhiteColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x3_WHITE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x3_WHITE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/white.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putWhiteColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_4x2_WHITE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_4x2_WHITE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/white.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putWhiteColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['put2D_2x4_WHITE'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 put2D_2x4_WHITE ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/white.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": putWhiteColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};


// ===================================================================================
// ------------------------------- Experimental --------------------------------------
// ===================================================================================




