
'use strict';

goog.provide('Blockly.JavaScript.texts');

goog.require('Blockly.JavaScript');

// ===================================================================================
// ------------------------------- Symbols -------------------------------------------
// ===================================================================================
Blockly.JavaScript['bwhat'] = function(block) {
  var text_symbol = block.getFieldValue('sym');
  var code = ';';
 
  lastSymbol = semicolon;
  
  return code;
};

Blockly.JavaScript['bempty'] = function(block) {
  var code = ' ';
 
  lastSymbol = empty;
  
  return code;
};


Blockly.JavaScript['bcomment'] = function(block) {
 
  var msg   = block.getFieldValue('msg');
  var code  = ' ';
  
  processEnd(COMMENT,'(* ' + msg + ' *)');
   
  return code;
};
