
// ===================================================================================
// ----------------------------------- offsets -------------------------------------------
// ===================================================================================

Blockly.Blocks['setOffset2D'] = {
  init: function() {      
    this.jsonInit({
      "message0": '%1 setOffset2D ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/Fotolia_offset.jpg",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": null,
      "nextStatement": null,
      "colour": offsetColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['incOffset2D'] = {
  init: function() {      
    this.jsonInit({
      "message0": '%1 incOffset2D ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/Fotolia_offset.jpg",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": offsetColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// -----------------------------------------------------------------------------------
Blockly.Blocks['decOffset2D'] = {
  init: function() {      
    this.jsonInit({
      "message0": '%1 decOffset2D ( %2 , %3 ) %4',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/Fotolia_offset.jpg",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "xVal",
          "text": "0"
        }
        ,
        {
          "type": "field_input",
          "name": "zVal",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": ["bput5", "bbuild"],
      "nextStatement": null,
      "colour": offsetColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};




