
// ===================================================================================
// ------------------------------- Symbols -------------------------------------------
// ===================================================================================


Blockly.Blocks['bwhat'] = {
  init: function() {      
    this.jsonInit({
      "message0": ';',
      //"previousStatement": [ "bopen" ],
      //"nextStatement": null,
      "output": "semicolon", // output type
      "colour": symbolColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

Blockly.Blocks['bempty'] = {
  init: function() {
    this.jsonInit({
      "message0": "",
      "output": "empty",  // the type output
      "colour": symbolColor,
      "tooltip": Blockly.Msg.LISTS_CREATE_EMPTY_TOOLTIP,
      "helpUrl": Blockly.Msg.LISTS_CREATE_EMPTY_HELPURL
    });
  }
};



Blockly.Blocks['bcomment'] = {
  init: function() {      
    this.jsonInit({
      "message0": '%1 (* %2 *)',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/comment.png",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "msg",
          "text": "==================================="
        }        
      ],
      "previousStatement": null,
      "nextStatement": null,
      "colour": symbolColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};



