
// ===================================================================================
// ----------------------------------- declarations ----------------------------------
// ===================================================================================

Blockly.Blocks['declaration_nullaryFunction'] = {
    init: function() {
      this.jsonInit({
        "message0": "%1 fun %2 () = (",
        "args0": [
                    {
                       "type"   : "field_image",
                       "src"    : "images/bricklayer_lite_images/Fotolia_book.jpg",
                       "width"  : imageWidth,
                       "height" : imageHeight,
                       "alt"    : "*"
                    }
                    ,        
                    {
                      "type": "field_input", 
                      "name": "nameOfFn",
                      "text": "myFunction"
                    }
                ],
        "args1": [
                    {
                        "type": "input_statement", 
                        "name": "body"
                    }                    
                    ,
                    {
                      "type": "input_value",
                      "name": "semi_or_epsilon",
                      "check": "semicolon"
                    }                    
                ], 
        "message1": " %1 ) %2",                                   
        "previousStatement": null,
        "nextStatement": null,
        "colour": declareColor
      });
    }
};


// -----------------------------------------------------------------------------------
Blockly.Blocks['declaration_function'] = {
    init: function() {
      this.jsonInit({
        "message0": "%1 fun  %2 ( %3 , %4 ) = (",
        "args0": [
                    {
                       "type"   : "field_image",
                       "src"    : "images/bricklayer_lite_images/Fotolia_book.jpg",
                       "width"  : imageWidth,
                       "height" : imageHeight,
                       "alt"    : "*"
                    }
                    ,        
                    {
                      "type": "field_input", 
                      "name": "nameOfFn",
                      "text": "myFunction"
                    }
                    ,        
                    {
                      "type": "field_input", 
                      "name": "x",
                      "text": "x"
                    }
                    ,        
                    {
                      "type": "field_input", 
                      "name": "z",
                      "text": "z"
                    }

                ],
        "args1": [
                    {
                        "type": "input_statement", 
                        "name": "body"
                    }                    
                    ,
                    {
                      "type": "input_value",
                      "name": "semi_or_epsilon",
                      "check": "semicolon"
                    }                    
                ], 
        "message1": " %1 ) %2",                                   
        "previousStatement": null,
        "nextStatement": null,
        "colour": declareColor
      });
    }
};

// ===================================================================================
// ----------------------------------- Function Calls --------------------------------
// ===================================================================================


Blockly.Blocks['bcallNullary'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 () %2',
      "args0": [
        {
          "type": "field_input",
          "name": "userFunName",
          "text": "myFunction"
        }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": null,
      "nextStatement": null,
      "colour": callColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};


Blockly.Blocks['bcall'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 ( %2 , %3 ) %4',
      "args0": [
        {
          "type": "field_input",
          "name": "userFunName",
          "text": "myFunction"
        }
        ,
        {
          "type": "field_input",
          "name": "xArg",
          "text": "0"
        }
        ,        
        {
          "type": "field_input",
          "name": "zArg",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": null,
      "nextStatement": null,
      "colour": callColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};




