
// ===================================================================================
// ----------------------------------- Shapes ----------------------------------------
// ===================================================================================
// 3D shapes are also possible http://threejs.org/

Blockly.Blocks['circleXZ'] = {
  init: function() {      
    this.jsonInit({
      "message0": '%1 circleXZ %2  %3 ( %4 , %5 ) %6',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/Fotolia_shapes.jpg",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,              
        {
          "type": "field_input",
          "name": "radius",
          "text": "radius"
        }
        ,              
        {
          "type"  : "field_colour",
          "name"  : "brick",
          "colour": "#ffffff"
        }        
        ,
        {
          "type": "field_input",
          "name": "xArg",
          "text": "0"
        }
        ,        
        {
          "type": "field_input",
          "name": "zArg",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": null,
      "nextStatement": null,
      "colour": callColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

Blockly.Blocks['ringXZ'] = {
  init: function() {      
    this.jsonInit({
      "message0": '%1 ringXZ %2  %3 %4 ( %5 , %6 ) %7',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/Fotolia_shapes.jpg",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,              
        {
          "type": "field_input",
          "name": "radius",
          "text": "radius"
        }
        ,              
        {
          "type": "field_input",
          "name": "thickness",
          "text": "thickness"
        }        
        ,              
        {
          "type"  : "field_colour",
          "name"  : "brick",
          "colour": "#ffffff"
        }        
        ,
        {
          "type": "field_input",
          "name": "xArg",
          "text": "0"
        }
        ,        
        {
          "type": "field_input",
          "name": "zArg",
          "text": "0"
         }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon"
        }
        
      ],
      "previousStatement": null,
      "nextStatement": null,
      "colour": callColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};




